import menu
from mediator import mediator, Event
import twister

import main
import player
import village
import spinny
import pygame

import twister_info

twisterz = []

class Terraform(object):
    def __init__(self, player):
        self.player = player
#        self.menu = menu.Terraform("%s_terraform" %(player))
        
    def startTurn(self):
        global in_terraform
        print "terraform startTurn"
        mediator.publishEvent(
            'turn_start', turnType='terraform', player=self.player)
        in_terraform = True
    
    def endTurn(self):
        global in_terraform
        print "terraform endTurn"
        mediator.publishEvent(
            'turn_end', turnType='terraform', player=self.player)
        in_terraform = False

class PlanAttack(object):
    def __init__(self, player):
        self.player = player

    def startTurn(self):
        global in_plan_attack
        print "plan_attack startTurn"
        mediator.publishEvent(
            'turn_start', turnType='plan_attack', player=self.player)
        in_plan_attack = True

    def endTurn(self):
        global in_plan_attack
        print "plan_attack endTurn"
        mediator.publishEvent(
            'turn_end', turnType='plan_attack', player=self.player)
        in_plan_attack = False
        
class Attack(object):
    def __init__(self, player):
        self.player = player
        
    def startTurn(self):
        global in_attack
        global twisterz
        print "Attack startTurn"
        mediator.publishEvent(
            'turn_start', turnType='attack', player=self.player)
        in_attack = True
        print "making a twisterz"
        # go through the twisters for player X and create them
        twisters = []
        if self.player == player.player0:
            twisters = spinny.twisters_player_1
        else:
            twisters = spinny.twisters_player_2
            
        for twister_info in twisters:
            print "Adding twister!"
        
            twisterie = twister.Twister(initPos=twister_info.initPos,
                                        radius=twister_info.radius,
                                        moveVector=twister_info.moveVector,
                                        twist=twister_info.twist,
                                        terrain=twister_info.terrain)

            print "initPos=%s, radius=%s, moveVector=%s, twist=%s\n" %(twisterie.position,
                                                                       twisterie.dia,
                                                                       twisterie.moveVector,
                                                                       twisterie.twist)

            twisterz.append(twisterie)

        # display the correct menu
        menu.in_game_menu.undisplayMenu()
        menu.attack_menu.displayMenu()

        if (not twisters):
            # if there were no tornadoes
            print "Pulblishing next turn - turn.py1"
            mediator.publishEvent("next_turn")
    
    def endTurn(self):
        global in_attack, twisterz
        print "attack endTurn"
        mediator.publishEvent(
            'turn_end', turnType='attack', player=self.player)
        in_attack = False
        twisterz = []

        # display the correct menu
        menu.in_game_menu.displayMenu()
        menu.attack_menu.undisplayMenu()
        
turns = []
turns.append(Terraform(player.player0))
turns.append(Terraform(player.player1))
turns.append(PlanAttack(player.player0))
turns.append(PlanAttack(player.player1))
turns.append(Attack(player.player0))
turns.append(Attack(player.player1))

current_turn = None
in_game = False
in_terraform = False
in_plan_attack = False
in_attack = False


def startTurnsListener(event):
    global current_turn, in_game
    current_turn = turns[0]
    in_game = True
    
    # Players get fresh huts
    player.player0.village = village.Village((200, 400), 100, 10) 
    player.player1.village = village.Village((600, 200), 100, 10)
    
    current_turn.startTurn()
mediator.addListener("start_turns", startTurnsListener)

def nextTurnListener(event):
    global current_turn
    print "NTL: event: %s" %(event)
    current_turn.endTurn()

    # If a player has 0 health, s/he loses!
    if ((player.player0.health <= 0)
        and (player.player1.health <= 0)):
        mediator.publishEvent('game_over', winner=None)
    elif (player.player0.health <= 0):
        mediator.publishEvent('game_over', winner=player.player1)
    elif (player.player1.health <= 0):
        mediator.publishEvent('game_over', winner=player.player0)
    else:
        i = (turns.index(current_turn) + 1) % len(turns)
        current_turn = turns[i]
        current_turn.startTurn()
mediator.addListener("next_turn", nextTurnListener)

def gameOverListener(event):
    global in_game, in_terraform, in_attack, in_plan_attack, twisterz
    
    in_game = False
    in_terraform = False
    in_plan_attack = False

    if (in_attack):
        # kill any exiting tornados
        for twisterie in twisterz:
            twisterie.seppuku()
        twisterz = []
        in_attack = False

    player.player0.village = None
    player.player1.village = None
mediator.addListener("game_over", gameOverListener)

def mouseButtonDownListener(event):
    x,y = event.pos
    # Ignore clicks around the menu space
    if x < 122 and y < 39:
        return
    if in_terraform:
        print "tfmbd"
        mediator.publishEvent(
            "tf_start_alter", pos=event.pos, button=event.button)
#    if in_plan_attack:
#        print "plats"
#        mediator.publishEvent(
#            "plan_attack_start", pos=event.pos, button=event.button)
    if in_attack:
        print "ambd"
        mediator.publishEvent(
            "attack_start", pos=event.pos, button=event.button)
    
mediator.addListener("mouse_button_down", mouseButtonDownListener)

def mouseButtonUpListener(event):
    if in_terraform:
        print "tfmbu"
        mediator.publishEvent(
            "tf_end_alter", pos=event.pos, button=event.button)
#    if in_plan_attack:
#        print "plate"
#        mediator.publishEvent(
#            "plan_attack_end", pos=event.pos, button=event.button)
    if in_attack:
        print "ambu"
        mediator.publishEvent(
            "attack_end", pos=event.pos, button=event.button)
    
mediator.addListener("mouse_button_up", mouseButtonUpListener)

def deadTwisterListener(event):
    """Cull dead twisters from the list."""
    if (event.twister in twisterz):
        twisterz.remove(event.twister)
    if (not twisterz):
        #We ran out of tornados
        print "Pulblishing next turn - turn.py1"
        mediator.publishEvent("next_turn")
mediator.addListener('twister_died', deadTwisterListener)
