
import math

class Vector2D(object):
	def __init__(self, x, y):
		self.vec = [float(x), float(y)]
	
	def __add__(self, other):
		return Vector2D(self.x + other.x, self.y + other.y)

	def __sub__(self, other):
		return Vector2D(self.x - other.x, self.y - other.y)

	def __mul__(self, other):
		return Vector2D(self.x * other, self.y * other)

	def rotate(self, radians):
		return Vector2D(
			(self.x * math.cos(radians)) - (self.y * math.sin(radians)),
			(self.y * math.cos(radians)) + (self.x * math.sin(radians)))
		
	def x():
	    doc = "x coord"
	    def fget(self):
	        return self.vec[0]
		def fset(self, value):
		    self.vec[0] = value
	    return locals()
	x = property(**x())

	def y():
	    doc = "y coord"
	    def fget(self):
	        return self.vec[1]
	    def fset(self, value):
	        self.vec[1] = value
	    return locals()
	y = property(**y())
	
	def length():
	    doc = "vector length"
	    def fget(self):
	        return math.sqrt((self.x ** 2) + (self.y ** 2))
	    return locals()
	length = property(**length())
	
	def angle():
	    doc = "vector angle"
	    def fget(self):
			try:
				return math.atan(self.y / self.x)
			except:
				return 0
	    return locals()
	angle = property(**angle())
	
	def __repr__(self):
		return "<Vector2D " + str(self.x) + ", " + str(self.y) + ">"  

if __name__ == '__main__':
	v0 = Vector2D(1,2)
	v1 = Vector2D(3,4)
	assert (v0 + v1).x == 4
	assert (v0 + v1).y == 6
	assert (v0 - v1).x == -2
	assert (v0 - v1).y == -2
	assert Vector2D(1,1).length == math.sqrt(2)
